Index: channels/chan_zap.c
===================================================================
--- channels/chan_zap.c	(revision 74550)
+++ channels/chan_zap.c	(working copy)
@@ -1760,6 +1760,22 @@
 	int x, res;
 	x = hs;
 	res = ioctl(fd, ZT_HOOK, &x);
+
+	if (errno & EBUSY) {
+		fd_set wfds;
+		struct timeval tv;
+
+		tv.tv_sec = 1;
+		tv.tv_usec = 0;
+
+		FD_ZERO(&wfds);
+		FD_SET(fd, &wfds);
+
+		select(fd+1, NULL, &wfds, NULL, &tv);
+	
+		res = ioctl(fd, ZT_HOOK, &x);
+	}
+
 	if (res < 0) 
 	{
 		if (errno == EINPROGRESS) return 0;
